﻿Imports System.Text.RegularExpressions
Imports System.IO

Public Class ClipsMainForm

    Private theClass As ClassSample = New ClassSample()
    Dim quantity As Integer
    Dim price As Double

    '' Structure sample (Form level variable)
    Public Structure StructSample
        Dim str As String
        Dim num As Integer
    End Structure

    '' Array of structure. Size is 3 where 2 is the last element (Form level variable)
    Public arrOfStruct(2) As StructSample

    '' File handles (Form level variable)
    Dim outFile As IO.StreamWriter
    Dim inFile As IO.StreamReader

    '' startup
    Private Sub ClipsMainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        lblMsg.Text = ""

        '' Curancy.
        Dim cash As Double = 1.245
        '' note: c2 includes $, c2&n2 both also rounds up
        TextBox1.Text = cash.ToString("n2")

        '' populate struct array with defaults
        arrOfStruct(0).str = "one, uno"
        arrOfStruct(0).num = 1
        arrOfStruct(1).str = "two, dos"
        arrOfStruct(1).num = 22
        arrOfStruct(2).str = "three, tres"
        arrOfStruct(2).num = 333
        '' populate the sample class as well, so that either the Struct or Class can be used
        theClass.setValues(arrOfStruct)


        Dim wrd As String
        For Each rec As StructSample In arrOfStruct
            '' string parsing includes startsWith, sub, indexOf, contains, etc)
            If (theClass.lang.StartsWith("es")) Then
                wrd = rec.str.Substring(rec.str.IndexOf(",") + 1)
            Else
                wrd = rec.str.Substring(0, rec.str.IndexOf(","))
            End If

            'add data to listbox 
            ListBox1.Items.Add((wrd + ":").PadRight(8, " ") + rec.num.ToString("n0").PadLeft(4, "0"))
        Next

    End Sub


    Private Function ValidateInput()
        lblMsg.Text = ""
        'remove all non-numeric (no need to warn due to primary purpose violation)
        TextBox1.Text = Regex.Replace(TextBox1.Text.Trim, "[^0-9. ]", "")

        If (TextBox1.Text.Contains(" ")) Then
            'should not be remaining spaces after string is cleaned or could be attempt to enter multiple numbers
            MsgBox("Please enter a single numeric value in the input fields")
            Return False
        ElseIf (TextBox1.Text.Contains(".")) Then
            'quantity must be integer (not sure if there is a better test for integer)
            MsgBox("We do not sell parts of a book (you are fired for cutting up a book!)")
            Return False
        ElseIf (TextBox1.Text = "") Then
            'do not do anything if null
            Return False
        End If

        'convert to Integer and or Double
        Integer.TryParse(TextBox1.Text, quantity)
        Double.TryParse("1.25", price)

        Return True
    End Function



    '' Exit Button
    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        lblMsg.Text = ""
        Me.Close()
    End Sub


    Private Sub cmbLanguage_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbLanguage.SelectedIndexChanged
        lblMsg.Text = ""
        theClass.changeLanguageInListBox(cmbLanguage, ListBox1)
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        lblMsg.Text = ""
        Dim txt As String = "A line of text, and another"
        If (Not IO.File.Exists("sample.csv")) Then
            outFile = IO.File.CreateText("cheques.csv")
            outFile.WriteLine("Line 1, Line 2")
            outFile.WriteLine(txt)
            outFile.Close()
        Else
            'Googled appending to a file and founf thisFileAppendaAllText function.  
            'Seems quick and easy to use (for this particular purpose).
            File.AppendAllText("sample.csv", txt + Chr(13) + Chr(10))
        End If
    End Sub

    Private Sub btnLoad_Click(sender As Object, e As EventArgs) Handles btnLoad.Click
        lblMsg.Text = "Not implemented yet"
    End Sub
End Class
